function PetEXPInfoBar_OnLoad()
	this:RegisterEvent("UNIT_PET");
	this:RegisterEvent("UNIT_PET_EXPERIENCE");
	this:RegisterEvent("UNIT_LEVEL");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("PLAYER_TARGET_CHANGED");
	this:RegisterEvent("UNIT_HAPPINESS");
	this:RegisterEvent("PET_BAR_UPDATE");
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("UNIT_AURA");
	this:RegisterEvent("LOOT_OPENED");
	this:RegisterEvent("LOOT_CLOSED");
	this:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	PetEXPBarLevelClusterBG:SetVertexColor(0,0,0, 0.65);
	PetBarShow_Onload();
	PetBarMin_Onload();
	PetBarHelp_Onload();
	PetBarBuff_Onload();
end

	-- Add your custom functions below this point

function PetEXPInfoBar_OnEvent(event)
	if (event == "COMBAT_LOG_EVENT_UNFILTERED") then
	local mypetBuffDest = UnitName("pet");
	local myBuffDest = UnitName("player");
		if ((arg2 == "SPELL_PERIODIC_ENERGIZE") and (arg4 == myBuffDest) and (arg7 == mypetBuffDest) and (arg10 == "Feed Pet Effect")) then 
--			ChatFrame6:AddMessage("arg1==" .. arg1 .. " arg2==" .. arg2 .. " arg3==" .. arg3 .. " arg4==" .. arg4 .. " arg5==" .. arg5 .. " arg6==" .. arg6 .. " arg7==" .. arg7 .. " arg8==" .. arg8 .. " arg9==" .. arg9 .. " arg10==" .. arg10 .. " arg11==" .. arg11 .. " arg12==" .. arg12 .. " arg13==" .. arg13, 1.0, 1.0, 1.0);
			PetEXPInfoBar_FeedPet();
		elseif ((arg2 == "SPELL_AURA_REMOVED") and (arg7 == mypetBuffDest) and (arg10 == "Feed Pet Effect")) then
			PetEXPInfoBar_FeedPet();
--			ChatFrame6:AddMessage("arg1==" .. arg1 .. " arg2==" .. arg2 .. " arg3==" .. arg3 .. " arg5==" .. arg5 .. " arg6==" .. arg6 .. " arg7==" .. arg7 .. " arg8==" .. arg8 .. " arg9==" .. arg9 .. " arg10==" .. arg10 .. " arg11==" .. arg11, 1.0, 1.0, 1.0);
		end
		if ((arg2 == "SPELL_AURA_REMOVED") and (arg7 == mypetBuffDest) and (arg10 == "Well Fed")) then
			PetEXPBarWellFed:Hide();
			PetEXPBarWellFedText:Hide();
--			ChatFrame6:AddMessage("arg2==" .. arg2 .. " arg7==" .. arg7 .. " arg10==" .. arg10, 1.0, 1.0, 1.0);
		end
	end
	function FirstLoadTime()
		if (PetXPBar_XValue == 0 or PetXPBar_YValue == 0 or PetXPBar_LockValue == 0) or not (PetXPBar_XValue or PetXPBar_YValue or PetXPBar_LockValue) then
			return true;
		else
			return false;
		end
	end
	if (event == "VARIABLES_LOADED") then
		if FirstLoadTime() then
			PetEXPInfoBar_DefaultPos();
		elseif not FirstLoadTime() then
			PetEXPInfoBar_SavePos();
		end
		PetEXPInfoBar_LockLoad();
	end
	if ( event == "PLAYER_ENTERING_WORLD" ) then
		PetEXPBarFeedText:Hide();
	end
	if ( event == "PET_BAR_UPDATE") then
		PetEXPInfoBar_Update();
	end
	if (event == "UNIT_PET" and arg1 == "player") then
		PetEXPInfoBar_Update();
	end
	if(event == "UNIT_AURA" and arg1 == "pet") then
		PetEXPInfoBar_Update();
		PetEXPInfoBar_WellFedCheck();
	end
	if (event == "UNIT_AURA") and (arg1 == "player") then
		PetEXPInfoBar_State();
--		ChatFrame6:AddMessage("arg1==" .. arg1, 1.0, 1.0, 1.0);
	end
	if ( event == "UNIT_LEVEL" and arg1 == "Pet") then
		PetEXPInfoBar_Update();
	end
	if ( event == "UNIT_PET_EXPERIENCE" ) then
		PetEXPInfoBar_Update();
	end
	if ( event == "UNIT_HAPPINESS" ) then
		PetEXPInfoBar_Update();
		PetEXPInfoBar_WellFedCheck();
	end
	if (event == "PLAYER_TARGET_CHANGED") or (event == "LOOT_OPENED") or (event == "LOOT_CLOSED") then
		PetEXPInfoBar_State();
	end
end

function PetEXPInfoBar_Update()
	local petLevel = UnitLevel("Pet");
	local currXP, nextXP = GetPetExperience();
	local petFamily = UnitCreatureFamily("Pet");
	if (UnitLevel("pet") == UnitLevel("player")) then
		if (currXP < 1) or (currXP == nil) then
			PetEXPInfoBarGauge:SetMinMaxValues(min(0, currXP), nextXP);
			PetEXPInfoBarGauge:SetValue(currXP);
			PetEXPInfoBarLabelText:Hide();
		else
			PetEXPInfoBarGauge:SetMinMaxValues(min(0, currXP), nextXP);
			PetEXPInfoBarGauge:SetValue(currXP);
			PetEXPInfoBarGauge:Show();
		end
	else
		PetEXPInfoBarGauge:SetMinMaxValues(min(0, currXP), nextXP);
		PetEXPInfoBarGauge:SetValue(currXP);
		PetEXPInfoBarGauge:Show();
	end
	PetEXPBarLevelText:SetText(petLevel);
	PetEXPBarFamilyText:SetText(petFamily);
	PetEXPInfoBar_PetLoyalty();
	PetEXPInfoBar_Speed();
	PetEXPInfoBar_Hunger();
	PetEXPInfoBar_State();
	PetEXPInfoBar_BuffCheck();
end

function PetEXPInfoBar_DefaultPos()
		PetInfoBarEXPGauge:ClearAllPoints();
		PetInfoBarEXPGauge:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 10, -125);
end

function PetEXPInfoBar_GetPos()
		PetXPBar_YValue = PetInfoBarEXPGauge:GetBottom();
		PetXPBar_XValue = PetInfoBarEXPGauge:GetLeft();
end

function PetEXPInfoBar_SavePos()
		PetInfoBarEXPGauge:ClearAllPoints();
		PetInfoBarEXPGauge:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", PetXPBar_XValue, PetXPBar_YValue);
end

function PetEXPInfoBar_PetLoyalty()
		local petbarLoyalty = GetPetLoyalty();
		if petbarLoyalty == "(Loyalty Level 6) Best Friend" then
			PetEXPBarLoyaltyText:Hide();
			return false;
		elseif petbarLoyalty == "(Loyalty Level 1) Rebellious" then
			PetEXPBarLoyaltyText:SetText("Rebellious (1)");
			PetEXPBarLoyaltyText:Show();
			return true;
		elseif petbarLoyalty == "(Loyalty Level 2) Unruly" then
			PetEXPBarLoyaltyText:SetText("Unruly (2)");
			PetEXPBarLoyaltyText:Show();
			return true;
		elseif petbarLoyalty == "(Loyalty Level 3) Submissive" then
			PetEXPBarLoyaltyText:SetText("Submissive (3)");
			PetEXPBarLoyaltyText:Show();
			return true;
		elseif petbarLoyalty == "(Loyalty Level 4) Dependable" then
			PetEXPBarLoyaltyText:SetText("Dependable (4)");
			PetEXPBarLoyaltyText:Show();
			return true;
		elseif petbarLoyalty == "(Loyalty Level 5) Faithful" then
			PetEXPBarLoyaltyText:SetText("Faithful (5)");
			PetEXPBarLoyaltyText:Show();
			return true;			
		end
end

function PetEXPInfoBar_LockToggle()
	if PetEXPInfoBar_IsLocked() then
		PetEXPInfoBar_LockUnSet();
	elseif not PetEXPInfoBar_IsLocked() then
		PetEXPInfoBar_LockSet();
	end
end

function PetEXPInfoBar_LockLoad()
	if FirstLoadTime() then
		PetEXPInfoBar_LockUnSet();
	elseif not PetEXPInfoBar_IsLocked() then
		PetEXPBarLockButton:SetVertexColor(0, 1.0, 0);
		PetInfoBarEXPGauge:SetMovable(true);
	else
		if PetEXPInfoBar_IsLocked() then
			PetEXPBarLockButton:SetVertexColor(1.0, 0, 0);
			PetInfoBarEXPGauge:SetMovable(false);
		end
	end
end	

function PetEXPInfoBar_LockSet()
	PetXPBar_LockValue = 1
	PetEXPBarLockButton:SetVertexColor(1.0, 0, 0);
	PetInfoBarEXPGauge:SetMovable(false);
end	

function PetEXPInfoBar_LockUnSet()
	PetXPBar_LockValue = 0
	PetEXPBarLockButton:SetVertexColor(0, 1.0, 0);
	PetInfoBarEXPGauge:SetMovable(true);
end

function PetEXPInfoBar_IsLocked()
	if PetXPBar_LockValue == 1 then
		return true;
	else
		return false;
	end
end

function PetEXPInfoBar_Speed()
	local Pet_AttackSpeed = UnitAttackSpeed("pet");
	PetEXPBarSpeedText:SetText(format("SPD: %.1f", Pet_AttackSpeed));
	PetEXPBarSpeedText:Show();
end

function PetEXPInfoBar_Hunger()
	local PetHappiness = GetPetHappiness();
	if not UnitIsDead("Pet") then
		if PetHappiness == 3 then
			PetEXPBarHungerText:Hide();
			return false;
		elseif PetHappiness == 2 then
			PetEXPBarHungerText:SetText("I'm Hungry");
			PetEXPBarHungerText:SetVertexColor(0.65, 0.90, 0.25);
			PetEXPBarHungerText:Show();
			return true;
		elseif PetHappiness == 1 then
			PetEXPBarHungerText:SetText("I'm Starving");
			PetEXPBarHungerText:SetVertexColor(1.0, 0.33, 0.13);
			PetEXPBarHungerText:Show();
			return true;
		else
			PetEXPBarHungerText:Hide();
			return false;
		end
	elseif UnitIsDead("Pet") then
		PetEXPBarHungerText:Hide();
	end	
end

function PetEXPInfoBar_State()
local tLevel = UnitLevel("Target");
local tdiffcolor = GetDifficultyColor(tLevel);
	if UnitClass("Player") == "Hunter" then
		if IsMounted() then
			PetInfoBarEXPGauge:Hide();
		elseif not IsMounted() then
			if ( PetHasActionBar() ) and not (UnitIsDead("Pet")) then
				if ( UnitLevel("pet") == UnitLevel("player") ) then
					if PetEXPBarLoyaltyText:IsShown() then
						if PetXPBar_MinValue == 1 then
 							if not UnitExists("target") then
								FeedText_Shown();
							elseif ( UnitExists("target") and UnitCanAttack("player", "target")) and TargetHighLevelTexture:IsShown() then
								if (UnitIsDead("target")) and (LootFrame:IsShown()) then
									PetInfoBarEXPGauge:Show();
								elseif (UnitIsDead("target")) and (not LootFrame:IsShown()) then
									FeedText_Shown();
								elseif (not UnitIsDead("target")) then
									PetInfoBarEXPGauge:Show();
								end
							elseif ( UnitExists("target") and UnitCanAttack("player", "target")) and not ((tdiffcolor.r == 0.5) and (tdiffcolor.g == 0.5) and (tdiffcolor.b == 0.5)) then
								if (UnitIsDead("target")) and (LootFrame:IsShown()) then
									PetInfoBarEXPGauge:Show();
								elseif (UnitIsDead("target")) and (not LootFrame:IsShown()) then
									FeedText_Shown();
								elseif (not UnitIsDead("target")) then
									PetInfoBarEXPGauge:Show();
								end
							elseif ( UnitExists("target") and UnitCanAttack("player", "target")) and ((tdiffcolor.r == 0.5) and (tdiffcolor.g == 0.5) and (tdiffcolor.b == 0.5)) then
								FeedText_Shown();
							elseif ( UnitExists("target") and (not UnitCanAttack("player", "target"))) then
								FeedText_Shown();
							end

						elseif (PetXPBar_MinValue == 0) or not (PetXPBar_MinValue) then
							PetInfoBarEXPGauge:Show();
						end
					elseif not PetEXPBarLoyaltyText:IsShown() then
						if PetXPBar_MinValue == 1 then  
							FeedText_Shown();
						elseif (PetXPBar_MinValue == 0) or not (PetXPBar_MinValue) then
							WellFed_Shown();
						end
						
					end
				elseif ( UnitLevel("pet") < UnitLevel("player") ) then
					if PetXPBar_MinValue == 1 then
 						if not UnitExists("target") then
							FeedText_Shown();
						elseif ( UnitExists("target") and UnitCanAttack("player", "target")) and TargetHighLevelTexture:IsShown() then
							if (UnitIsDead("target")) and (LootFrame:IsShown()) then
								PetInfoBarEXPGauge:Show();
							elseif (UnitIsDead("target")) and (not LootFrame:IsShown()) then
								FeedText_Shown();
							elseif (not UnitIsDead("target")) then
								PetInfoBarEXPGauge:Show();
							end
						elseif ( UnitExists("target") and UnitCanAttack("player", "target")) and not ((tdiffcolor.r == 0.5) and (tdiffcolor.g == 0.5) and (tdiffcolor.b == 0.5)) then
							if (UnitIsDead("target")) and (LootFrame:IsShown()) then
								PetInfoBarEXPGauge:Show();
							elseif (UnitIsDead("target")) and (not LootFrame:IsShown()) then
								FeedText_Shown();
							elseif (not UnitIsDead("target")) then
								PetInfoBarEXPGauge:Show();
							end
						elseif ( UnitExists("target") and UnitCanAttack("player", "target")) and ((tdiffcolor.r == 0.5) and (tdiffcolor.g == 0.5) and (tdiffcolor.b == 0.5)) then
							FeedText_Shown();
						elseif ( UnitExists("target") and (not UnitCanAttack("player", "target"))) then
							FeedText_Shown();
						end
					elseif (PetXPBar_MinValue == 0) or not (PetXPBar_MinValue) then
						PetInfoBarEXPGauge:Show();
					end
				end
			elseif ( PetHasActionBar() ) and (UnitIsDead("Pet")) then
				PetInfoBarEXPGauge:Hide();
			else
				PetInfoBarEXPGauge:Hide();
			end
		elseif not ( UnitClass("Player") == "Hunter" ) then
			PetInfoBarEXPGauge:Hide();
		end
	end
end

function PetEXPInfoBar_FeedPet()
	if (HappyFeed() == true) then
		PetEXPBarFeedText:Show();
	elseif (HappyFeed() == false) then
		PetEXPBarFeedText:Hide();
	end
end

function HappyFeed()
	if (arg12) and (not ((arg12 == "BUFF") or (arg12 == BUFF))) then
		PetEXPBarFeedText:SetText(arg12 .. " H");
		return true;
	elseif ((arg12 == "BUFF") or (arg12 == BUFF)) then
		return false;
	end
end

function WellFed_Shown()
	if PetEXPBarWellFed:IsShown() then
		PetInfoBarEXPGauge:Show();
	elseif not PetEXPBarWellFed:IsShown() then
		FeedText_Shown();
	end
end

function FeedText_Shown()
	if ( PetEXPInfoBar_Hunger() == false ) and (not PetEXPBarFeedText:IsShown()) then
		PetInfoBarEXPGauge:Hide();
	elseif ( PetEXPInfoBar_Hunger() == false ) and (PetEXPBarFeedText:IsShown()) then
		PetInfoBarEXPGauge:Show();
	elseif ( PetEXPInfoBar_Hunger() == true ) and (PetEXPBarFeedText:IsShown()) then
		PetInfoBarEXPGauge:Show();
	elseif ( PetEXPInfoBar_Hunger() == true ) and (not PetEXPBarFeedText:IsShown()) then
		PetInfoBarEXPGauge:Show();
	elseif ( not PetEXPInfoBar_Hunger() == true ) then
		PetInfoBarEXPGauge:Hide();
	end
end

function PetEXPInfoBar_BuffCheck()
	local buffs, i = { }, 1;
	local buff = UnitBuff("pet", i);
	while buff do
 		 buffs[#buffs + 1] = buff;
  		i = i + 1;
  		buff = UnitBuff("pet", i);
	end
	if #buffs < 1 then
  		buffs = "Pet has no buffs";
	else
  		buffs[1] = "Pet Has: "..buffs[1];
  		buffs = table.concat(buffs, ", ");
	end
	if not ((string.find(buffs, "Well Fed()")) or (string.find(buffs, "(.+) Well Fed()"))) then
		PetEXPBarWellFed:Hide();
		PetEXPBarWellFedText:Hide();
	end
	if not ((string.find(buffs, "Feed Pet Effect()")) or (string.find(buffs, "(.+) Feed Pet Effect()"))) then
		PetEXPBarFeedText:Hide();
	end
--	ChatFrame6:AddMessage(buffs);
end

function PetEXPInfoBar_WellFedCheck()
	if WellFed_Show == 1 then
		for i=1,40 do
		local	name, rank, icon, count, duration, timeLeft = UnitBuff("pet",i); 
			if name then
--				DEFAULT_CHAT_FRAME:AddMessage("name = " .. name .. " rank = " .. rank .. " icon = " .. icon .. " count = " .. count .. " dur = " .. duration .. " time = "  ..timeLeft, 1.0,1.0,1.0);
				if (name == "Well Fed") then
						PetEXPBarWellFed:Show();
						if (timeLeft >= 60) then
							PetEXPBarWellFedText:SetText(format("%.0f",timeLeft/60) .. "m");
						elseif (timeLeft < 60) then
							PetEXPBarWellFedText:SetText(format("%.0f",timeLeft) .. "s");
						end
						PetEXPBarWellFedText:Show();
				elseif (not name == "Well Fed") then
						PetEXPBarWellFed:Hide();
						PetEXPBarWellFedText:Hide();
				end
			end 
		end
	elseif (WellFed_Show == 0) or not (WellFed_Show) then
		PetEXPBarWellFed:Hide();
		PetEXPBarWellFedText:Hide();	
	end
end

function PetBarShow_Command(cmd)
	if ( PetHasActionBar() ) then
		if not (PetActionBarFrame:IsShown()) then
			PetActionBarFrame:Show();
		end
	end
end

function PetBarShow_Onload()
	SlashCmdList["PETBARSHOW"] = PetBarShow_Command;
	SLASH_PETBARSHOW1 = "/petbarshow";
end

function PetBarMin_Command(cmd)
	if UnitClass("Player") == "Hunter" then
		if (PetXPBar_MinValue == 0) or not (PetXPBar_MinValue) then
			PetXPBar_MinValue = 1;
			if ChatFrame6:IsShown() then
				ChatFrame6:AddMessage("Pet XP Bar is now minimized for trivial targets.", 1.0, 1.0, 0.0);
			else
				DEFAULT_CHAT_FRAME:AddMessage("Pet XP Bar is now minimized for trivial targets.", 1.0, 1.0, 0.0);
			end

		elseif (PetXPBar_MinValue == 1) then
			PetXPBar_MinValue = 0;
			if ChatFrame6:IsShown() then
				ChatFrame6:AddMessage("Pet XP Bar is now in full display mode.", 1.0, 1.0, 0.0);
			else
				DEFAULT_CHAT_FRAME:AddMessage("Pet XP Bar is now in full display mode.", 1.0, 1.0, 0.0);
			end

		end
	else
		if ChatFrame6:IsShown() then
			ChatFrame6:AddMessage("You must be a Hunter to use this command.", 1.0, 1.0, 0.0);
		else
			DEFAULT_CHAT_FRAME:AddMessage("You must be a Hunter to use this command.", 1.0, 1.0, 0.0);
		end
	end
 
	PetEXPInfoBar_State();
end

function PetBarMin_Onload()
	SlashCmdList["PETBARMIN"] = PetBarMin_Command;
	SLASH_PETBARMIN1 = "/petbarmin";
end

function PetBarHelp_Command(cmd)
	if UnitClass("Player") == "Hunter" then
		if ChatFrame6:IsShown() then
			ChatFrame6:AddMessage("Type /petbarmin to toggle full and minimized mode.", 1.0, 1.0, 0.0);
			ChatFrame6:AddMessage("Type /petbarbuff to toggle the 'Well Fed' display.", 1.0, 1.0, 0.0);
		else
			DEFAULT_CHAT_FRAME:AddMessage("Type /petbarmin to toggle full and minimized mode.", 1.0, 1.0, 0.0);
			DEFAULT_CHAT_FRAME:AddMessage("Type /petbarbuff to toggle the 'Well Fed' display.", 1.0, 1.0, 0.0);
		end
	else
		if ChatFrame6:IsShown() then
			ChatFrame6:AddMessage("You must be a Hunter to use this command.", 1.0, 1.0, 0.0);
		else
			DEFAULT_CHAT_FRAME:AddMessage("You must be a Hunter to use this command.", 1.0, 1.0, 0.0);
		end
	end
end

function PetBarHelp_Onload()
	SlashCmdList["PETBARHELP"] = PetBarHelp_Command;
	SLASH_PETBARHELP1 = "/petbarhelp";
end

function PetBarBuff_Command(cmd)
	if UnitClass("Player") == "Hunter" then
		if (WellFed_Show == 0) or not (WellFed_Show) then
			WellFed_Show = 1;
			if ChatFrame6:IsShown() then
				ChatFrame6:AddMessage("'Well Fed' will now show.", 1.0, 1.0, 0.0);
			else
				DEFAULT_CHAT_FRAME:AddMessage("'Well Fed' will now show.", 1.0, 1.0, 0.0);
			end
		elseif (WellFed_Show == 1) then
			WellFed_Show = 0;
			if ChatFrame6:IsShown() then
				ChatFrame6:AddMessage("'Well Fed' will now hide.", 1.0, 1.0, 0.0);
			else
				DEFAULT_CHAT_FRAME:AddMessage("'Well Fed' will now hide.", 1.0, 1.0, 0.0);
			end

		end
	else
		if ChatFrame6:IsShown() then
			ChatFrame6:AddMessage("You must be a Hunter to use this command.", 1.0, 1.0, 0.0);
		else
			DEFAULT_CHAT_FRAME:AddMessage("You must be a Hunter to use this command.", 1.0, 1.0, 0.0);
		end
	end
	PetEXPInfoBar_WellFedCheck();
end

function PetBarBuff_Onload()
	SlashCmdList["PETBARBUFF"] = PetBarBuff_Command;
	SLASH_PETBARBUFF1 = "/petbarbuff";
end



